/* David Leonard, 2001. Public domain. */
/* $Id: dump.c,v 1.2 2002/02/07 01:09:25 d Exp $ */

/*
 * Debugging: dump of all i/o state.
 */
#include <stdio.h>
#include <poll.h>

#include <sys/queue.h>

#include "io.h"
#include "conn.h"
#include "buffer.h"
#include "dump.h"

static void
dump1(pfd, conn)
	struct pollfd *pfd;
	struct conn *conn;
{
	fprintf(stderr, "\tpfd[fd=%-2d ev=%c%c rev=%c%c]",
		pfd->fd,
		pfd->events & POLLIN   ? 'I' : '.',
		pfd->events & POLLOUT  ? 'O' : '.',
		pfd->revents & POLLIN  ? 'I' : '.',
		pfd->revents & POLLOUT ? 'O' : '.'
	);
	if (conn != NULL)
		fprintf(stderr, "  buf[r=%-3d w=%-3d]  io[%-6s fd=%-2d]",
			buffer_len(conn->in),
			buffer_len(conn->out),
			conn->io->io_op->iop_name,
			IO_FILENO(conn->io));
	fprintf(stderr, "\n");
}

void
dump(pfd)
	struct pollfd *pfd;
{
	int i;
	struct conn *conn;
	
	fprintf(stderr, "dump:\n");
	dump1(&pfd[0], NULL);
	i = 1;
	SLIST_FOREACH(conn, &connhead, link) {
		dump1(&pfd[i], conn);
		i++;
	}
}
