/* $Id: io.h,v 1.2 2002/02/07 01:09:25 d Exp $ */

/*
 * I/O (pollable stream) interface
 */

struct pollfd;
struct io;

struct io_op {
	char	*iop_name;
	int	(*iop_read)(struct io *, char *, int);
	int	(*iop_write)(struct io *, char *, int);
	void	(*iop_free)(struct io *);
	int	(*iop_fileno)(struct io *);
	int	(*iop_poll)(struct io *, struct pollfd *);
	int	iop_secure;
};

struct io {
	struct io_op	*io_op;
};

/* Read up to sz bytes; returns actual number of bytes read or -1 */
#define IO_READ(io,buf,sz)	((*(io)->io_op->iop_read)(io,buf,sz))
/* Write up to sz bytes; returns actual number of bytes written or -1 */
#define IO_WRITE(io,buf,sz)	((*(io)->io_op->iop_write)(io,buf,sz))
/* Deallocate io object */
#define IO_FREE(io)		((*(io)->io_op->iop_free)(io))
/* Return the file descriptor associated with the io (or -1 if none) */
#define IO_FILENO(io)		((*(io)->io_op->iop_fileno)(io))
/* Set up a pollfd structure to poll this io for read. Return -1 if none. */
#define IO_POLL(io,pfd)		((*(io)->io_op->iop_poll)(io,pfd))
/* Return true if this io is secure */
#define IO_SECURE(io)		((io)->io_op->iop_secure)
